local Cottage = Class{__includes = require 'modules.entity'}
local Explosion = require 'modules.explosion'
local Rubble = require 'modules.rubble'

-----------------------------------------------------------
-- Init functions
-----------------------------------------------------------
function Cottage:init(x,y)
  self.pos = Vector(x,y)

  self.hp = 20


  self.w = 16
  self.h = 16
  self.quad = lg.newQuad(64, 8, 16, 16, SPRITESHEET:getDimensions())
  self.zIndex = 4

  self.flammability = .5
  self.fireDuration = 20

  Game.world:add(self, self.pos.x, self.pos.y, self.w, self.h)
end

-----------------------------------------------------------
-- Update functions
-----------------------------------------------------------
-- function Cottage:update(dt)
--
-- end
-----------------------------------------------------------
-- Draw functions
-----------------------------------------------------------
function Cottage:draw()
  local x, y = self.pos:unpack()
  lg.draw(SPRITESHEET, self.quad, x, y)
end

-----------------------------------------------------------
-- Gameplay functions
-----------------------------------------------------------
function Cottage:receiveDamage(amt, src)
  self.hp = self.hp - amt
  if self.hp <= 0 then
    self:kill()
  end
end

function Cottage:kill()
  local x, y = self.pos.x, self.pos.y
  self:remove()
  local explosionChance = .1
  if love.math.random() <= explosionChance then
    table.insert(Game.entities, Explosion(x, y, true))
  end

  table.insert(Game.entities, Rubble(x    , y    , 'brick'))
  table.insert(Game.entities, Rubble(x + 8, y    , 'brick'))
  table.insert(Game.entities, Rubble(x    , y + 8, 'brick'))
  table.insert(Game.entities, Rubble(x + 8, y + 8, 'brick'))
end
return Cottage
