local Rubble = Class{__includes = require 'modules.entity'}

-----------------------------------------------------------
-- Init functions
-----------------------------------------------------------
function Rubble:init(x,y, which)
  self.pos = Vector(x,y)

  self.w = 8
  self.h = 8
  self.zIndex = 2

  self.potentialQuads = {
    brick = {
      {112, 0},
      {120, 0},
      {112, 8},
      {120, 8}
    },
    stump = {112, 16},
    wood = {120, 16}
  }

  local q = self.potentialQuads[which]

  if type(q[1]) == 'table' then
    self:chooseRandomQuad(q)
  elseif type(q[1]) == 'number' then
    self:setQuad(q)
  else
    self:remove()
  end

  -- if type(self.potentialQuads[which][1]) == 'table' then
  --   self:chooseRandomQuad(self.potentialQuads[which])
  -- elseif self.potentialQuads[which] then
  --   self:setQuad(self.potentialQuads[which])
  -- else
  --   self:remove()
  -- end

  self.flammability = 0
  self.isMobile = false
end

function Rubble:chooseRandomQuad(t)
  local i = love.math.random(1, #t)
  self:setQuad(t[i])
end

function Rubble:setQuad(t)
  self.quad = lg.newQuad(t[1], t[2], 8,8, SPRITESHEET:getDimensions())
end
-----------------------------------------------------------
-- Update functions
-----------------------------------------------------------
-- function Rubble:update(dt)
--
-- end

-----------------------------------------------------------
-- Draw functions
-----------------------------------------------------------
function Rubble:draw()
  local x, y = self.pos:unpack()
  lg.draw(SPRITESHEET, self.quad, x, y)
end

-----------------------------------------------------------
-- Gameplay functions
-----------------------------------------------------------


return Rubble
