local Tree = Class{__includes = require 'modules.entity'}
local Explosion = require 'modules.explosion'
local Rubble = require 'modules.rubble'

-----------------------------------------------------------
-- Init functions
-----------------------------------------------------------
function Tree:init(x,y)
  self.pos = Vector(x,y)
  self.hp = 10


  self.w = 8
  self.h = 8
  local quadX = 72 + love.math.random(0,3) * 8
  self.quad = lg.newQuad(quadX, 0, 8, 8, SPRITESHEET:getDimensions())
  self.zIndex = 4

  self.flammability = .5

  Game.world:add(self, self.pos.x, self.pos.y, self.w, self.h)
end

-----------------------------------------------------------
-- Update functions
-----------------------------------------------------------
function Tree:update(dt)

end
-----------------------------------------------------------
-- Draw functions
-----------------------------------------------------------
function Tree:draw()
  local x, y = self.pos:unpack()
  lg.draw(SPRITESHEET, self.quad, x, y)
end

-----------------------------------------------------------
-- Gameplay functions
-----------------------------------------------------------
function Tree:receiveDamage(amt, src)
  self.hp = self.hp - amt
  if self.hp <= 0 then
    self:kill()
  end
end

function Tree:kill()
  local x, y = self.pos.x, self.pos.y
  local explosionChance = .1
  if love.math.random() <= explosionChance then
    table.insert(Game.entities, Explosion(x,y, true))
  end
  table.insert(Game.entities, Rubble(x, y, 'stump'))
  self:remove()
end

return Tree
