local Wheat = Class{__includes = require 'modules.entity'}
local Explosion = require 'modules.explosion'

-----------------------------------------------------------
-- Init functions
-----------------------------------------------------------
function Wheat:init(x,y)
  self.pos = Vector(x,y)

  self.hp = 10

  self.w = 8
  self.h = 8
  self.quad = lg.newQuad(56, 0, 8, 8, SPRITESHEET:getDimensions())
  self.zIndex = 1
  self.collides = false
  self.flammability = .5

  Game.world:add(self, self.pos.x, self.pos.y, self.w, self.h)
end

-----------------------------------------------------------
-- Update functions
-----------------------------------------------------------
function Wheat:update(dt)

end
-----------------------------------------------------------
-- Draw functions
-----------------------------------------------------------
function Wheat:draw()
  local x, y = self.pos:unpack()
  lg.draw(SPRITESHEET, self.quad, x, y)
end

-----------------------------------------------------------
-- Gameplay functions
-----------------------------------------------------------
function Wheat:receiveDamage(amt, src)
  self.hp = self.hp - amt
  if self.hp <= 0 then
    self:kill()
  end
end

function Wheat:kill()
  self:remove()
  local explosionChance = .1
  if love.math.random() <= explosionChance then
    table.insert(Game.entities, Explosion(self.pos.x, self.pos.y, true))
  end
end

return Wheat
