local settings = require 'setup.settings'

InstructionScreen = {}
-----------------------------------------------------------
-- Init functions
-----------------------------------------------------------
function InstructionScreen:init()
  self.strings = {}
  self.strings[1] = [[
An EVIL WIZARD has transformed KING ROY into a giant monster!

The villagers are scared and confused by their monstrous monarch. You may have to kill them before they slay you.

[Press Space to continue]
]]
  self.strings[2] =[[
Find the WIZARD and seek your REVENGE!

RECLAIM your rightful THRONE!

[Press Space to continue]
]]
  self.strings[3] = [[
CONTROLS

[WASD] or [ARROWS] to MOVE

[SPACE] to ATTACK

[M] to MUTE

[P] to PAUSE

[Press Space to begin]
]]
end

function InstructionScreen:enter()
    self.currentString = 1
end

-----------------------------------------------------------
-- Update functions
-----------------------------------------------------------
function InstructionScreen:update(dt)

end

-----------------------------------------------------------
-- Draw functions
-----------------------------------------------------------
function InstructionScreen:draw()
  local str = self.strings[self.currentString]
  local x, y = 0, 8
  local limit = settings.pxWidth
  local align = 'center'

  lg.setCanvas(TINYCANVAS)
  lg.clear({38, 43, 68})
  lg.setColor({255,255,255})

  lg.printf(str, x, y, limit, align)

  lg.setCanvas()
  lg.draw(TINYCANVAS, 0, 0, 0, 2, 2)
end


-----------------------------------------------------------
-- Input functions
-----------------------------------------------------------

function InstructionScreen:keypressed(key, code)
  if key == 'return' or key == 'space' then
    self.currentString = self.currentString + 1

    if self.currentString > #self.strings then
      self.currentString = self.currentString - 1
      Gamestate.transition(Game)
    end
  end
end
